////////////////////////////////////////////////////////////////////////////////
// CONFIDENTIAL and PROPRIETARY software of Magewell Electronics Co., Ltd.
// Copyright (c) 2011-2014 Magewell Electronics Co., Ltd. (Nanjing)
// All rights reserved.
// This copyright notice MUST be reproduced on all authorized copies.
////////////////////////////////////////////////////////////////////////////////
#ifndef __MW_DEVICE_H__
#define __MW_DEVICE_H__

#include "ospi/ospi.h"

#include "mw-procapture-extension-private.h"
#include "mw-linux.h"

struct frame_settings {
    short                                   brightness;
    short                                   contrast;
    short                                   hue;
    short                                   saturation;

    MWCAP_VIDEO_PROCESS_SETTINGS            process_settings;
};

struct mw_device {
    struct capture_channel *    capch; /* low level card driver */
    os_mutex_t                  dev_mutex; /* device global mutex */

    /* default settings */
    struct frame_settings       settings;
    os_spinlock_t               settings_lock;

    os_dma_par_t                dma_priv;

    bool                        supported_multi_stream;
};

int mw_device_init(struct mw_device *mw_dev);

void mw_device_deinit(struct mw_device *mw_dev);

long mw_device_ioctl(struct mw_device *mwdev,  os_iocmd_t cmd, void *arg);

#endif /* __MW_DEVICE_H__ */
